/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8190_SUPTRG_CONCAT_PZO_PAGTO                                         */
/*                                                                            */
/* Descrio:                                                                 */
/* Concatena os prazos de pagamento para forma de pagamento varivel          */    
/*                                                                            */
/* Criao:                                                                   */
/* 03/04/2000 - Yoris L. de Souza                                               */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'CONCAT_PZO_PAGTO'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER CONCAT_PZO_PAGTO
  GO

CREATE TRIGGER CONCAT_PZO_PAGTO
ON PZOPGTITMCOL
FOR INSERT, UPDATE, DELETE

AS

DECLARE @V_CDFILIAL     VARCHAR(4);
DECLARE @V_NRCOLEPRECO  VARCHAR(10);
DECLARE @V_CDFORNECED   VARCHAR(21);
DECLARE @V_CDREGIAO     VARCHAR(3);
DECLARE @V_CDPRODUTO    VARCHAR(10);
DECLARE @V_CDMARCA      VARCHAR(5);

DECLARE @V_NRPGTCOLCAR  VARCHAR(1000);
DECLARE @V_NRPZOPGT     VARCHAR(10);
DECLARE @V_VRPERPGT     VARCHAR(10);

BEGIN

 SET @V_NRPGTCOLCAR = '';

 SELECT
  DISTINCT
  @V_CDFILIAL    =   CDFILIAL,
  @V_NRCOLEPRECO =   NRCOLEPRECO,
  @V_CDFORNECED  =   CDFORNECED,
  @V_CDREGIAO    =   CDREGIAO,
  @V_CDPRODUTO   =   CDPRODUTO,
  @V_CDMARCA     =   CDMARCA
 FROM INSERTED;
 IF @@ROWCOUNT = 0
 BEGIN
   SELECT
    DISTINCT
    @V_CDFILIAL    =   CDFILIAL,
    @V_NRCOLEPRECO =   NRCOLEPRECO,
    @V_CDFORNECED  =   CDFORNECED,
    @V_CDREGIAO    =   CDREGIAO,
    @V_CDPRODUTO   =   CDPRODUTO,
    @V_CDMARCA     =   CDMARCA
   FROM DELETED;
 END;

 DECLARE C_CONCAT CURSOR FOR
 SELECT CONVERT(VARCHAR, NRDIASPGTCOL),
        CONVERT(VARCHAR, VRPERCPGTCOL)
 FROM PZOPGTITMCOL
 WHERE
    @V_CDFILIAL    =   CDFILIAL    AND
    @V_NRCOLEPRECO =   NRCOLEPRECO AND
    @V_CDFORNECED  =   CDFORNECED  AND
    @V_CDREGIAO    =   CDREGIAO    AND
    @V_CDPRODUTO   =   CDPRODUTO   AND
    @V_CDMARCA     =   CDMARCA
 ORDER BY CONVERT(VARCHAR, NRDIASPGTCOL);

 OPEN C_CONCAT;

 FETCH NEXT FROM C_CONCAT INTO @V_NRPZOPGT, @V_VRPERPGT

 WHILE (@@FETCH_STATUS = 0)
 BEGIN

   SET @V_NRPGTCOLCAR = @V_NRPGTCOLCAR + @V_NRPZOPGT
          + '*' +  @V_VRPERPGT + '_';

   FETCH NEXT FROM C_CONCAT INTO @V_NRPZOPGT, @V_VRPERPGT

 END;
 CLOSE C_CONCAT;
 DEALLOCATE C_CONCAT;

 IF @V_NRPGTCOLCAR = '' BEGIN
    SET @V_NRPGTCOLCAR = NULL;
 END;
 UPDATE ITEMCOLE
 SET DSPZOPGTCONC = @V_NRPGTCOLCAR
 WHERE
    @V_CDFILIAL    =   CDFILIAL    AND
    @V_NRCOLEPRECO =   NRCOLEPRECO AND
    @V_CDFORNECED  =   CDFORNECED  AND
    @V_CDREGIAO    =   CDREGIAO    AND
    @V_CDPRODUTO   =   CDPRODUTO   AND
    @V_CDMARCA     =   CDMARCA;

END;
GO
